'From Squeak 2.4c of May 10, 1999 on 29 July 1999 at 7:28:15 pm'!
Object subclass: #ConversionUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki'!
Object subclass: #NuSwikiPage
	instanceVariableNames: 'id path book date time name user text settings temp beingWritten '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki'!
Object subclass: #SwikiBook
	instanceVariableNames: 'path pages pageAddresses bookAddresses pageActions bookActions pageTemplates bookTemplates settings temp formatter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki'!
Object subclass: #SwikiError
	instanceVariableNames: 'httpMessage httpStatusCode '
	classVariableNames: 'Common '
	poolDictionaries: ''
	category: 'Swiki'!
ComancheModule subclass: #SwikiModule
	instanceVariableNames: 'book '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki'!
HttpRequest subclass: #SwikiRequest
	instanceVariableNames: 'urlTokens urlPrefix '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki'!
Object subclass: #TextFormatter
	instanceVariableNames: 'match formattingArray '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki'!
TextFormatter subclass: #PageFormatter
	instanceVariableNames: 'storeID '
	classVariableNames: 'FromSafeUrl RemoveCrLf ToSafeUrl '
	poolDictionaries: ''
	category: 'Swiki'!
TextFormatter subclass: #TemplateFormatter
	instanceVariableNames: 'book '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki'!
NuSwikiPage subclass: #XmlSwikiPage
	instanceVariableNames: ''
	classVariableNames: 'FromXml ToXml '
	poolDictionaries: ''
	category: 'Swiki'!

!ComancheModule class methodsFor: 'web server packages' stamp: 'JFR 7/26/1999 16:25'!
swikiWebServer
	"This creates a swiki server for all folders in a subdirectory named swiki"
	| delim swikiDir webServer swikiServer fileServer uploadServer uploadPostServer |

	webServer _ self newModuleNamed: 'comanche'.
	delim _ String with: FileDirectory pathNameDelimiter.
	swikiDir _ FileDirectory default pathName, delim, 'swiki', delim.
	(FileDirectory on: swikiDir) directoryNames do: [:dName |
		swikiServer _ SwikiModule newModuleNamed: dName.
		swikiServer book: (SwikiBook fromPath: (swikiDir, dName, delim)).
		fileServer _ FileServerModule newModuleNamed: (dName, '/files').
		fileServer privWorkDirNamed: (swikiDir, dName, delim, 'files', delim).
		uploadServer _ FileServerModule newModuleNamed: (dName, '/uploads').
		uploadServer privWorkDirNamed: (swikiDir, dName, delim, 'uploads', delim).
		uploadPostServer _ MultipartPostModule newModuleNamed: 'upload'.
		uploadPostServer privWorkDirNamed: (swikiDir, dName, delim, 'uploads', delim).
		uploadPostServer privTempDirNamed: (swikiDir, dName, delim, 'uploads', delim).
		uploadServer modules add: uploadPostServer.
		swikiServer modules add: uploadServer.
		swikiServer modules add: fileServer.
		swikiServer modules add: uploadPostServer.
		webServer modules add: swikiServer].
	^webServer! !


!ConversionUtility commentStamp: '<historical>' prior: 0!
ConversionUtility

This class is to convert old style swikis (under PluggableWebServer) to the new swiki.

This intentionally is left as one class so that it can be easily removed in later releases without leaving methods all over the place.

"Not yet implemented" - Je77 20 July 99 !

!NuSwikiPage commentStamp: '<historical>' prior: 0!
NuSwikiPage

This is an abstract class for swiki pages that are part of a SwikiBook. The subclasses are based on the way that the information is stored; a subclass should overwrite these methods: backup, load, versions, write, and probably text.

Instance Variables:
id = numerical ID of the page
path = file name to where the page is being stored
book = the book the page belongs to
date = the last date the page was edited
time = the last time the page was edited
name = the name of the page
user = the last user to edit the page
text = an object that contains information on how to get the text for the page
settings = a place for a swiki to put settings specific to the page
temp = a place to keep settings for the page that don't have to be saved (for instance, caches).
beingWritten = a flag that is true when the file is being written and false or nil otherwise!

!NuSwikiPage methodsFor: 'accessing'!
beingWritten
	^(beingWritten = true)! !

!NuSwikiPage methodsFor: 'accessing'!
beingWritten: aBoolean
	beingWritten _ aBoolean! !

!NuSwikiPage methodsFor: 'accessing'!
book
	^book! !

!NuSwikiPage methodsFor: 'accessing'!
book: theSwikiBook
	book _ theSwikiBook! !

!NuSwikiPage methodsFor: 'accessing'!
date
	^date! !

!NuSwikiPage methodsFor: 'accessing'!
date: aDate
	date _ aDate! !

!NuSwikiPage methodsFor: 'accessing'!
id
	^id! !

!NuSwikiPage methodsFor: 'accessing'!
id: anInteger
	id _ anInteger! !

!NuSwikiPage methodsFor: 'accessing'!
name
	^name! !

!NuSwikiPage methodsFor: 'accessing'!
name: aString
	name _ aString! !

!NuSwikiPage methodsFor: 'accessing'!
nameUnique: aString
	"Names the page only if there is no other page in the book with that name."
	| copy |

	(aString = name) ifFalse: ["It only needs to be checked if name is different"
		(book hasPageNamed: aString)
			ifTrue: ["Check for names of aString, ' #X'."
				copy _ 2.
				[book hasPageNamed: (aString, ' #', copy asString)] whileTrue: [copy _ copy + 1].
				self name: (aString, ' #', copy asString)]
			ifFalse: [self name: aString]]! !

!NuSwikiPage methodsFor: 'accessing'!
path
	^path! !

!NuSwikiPage methodsFor: 'accessing'!
path: pathName
	path _ pathName! !

!NuSwikiPage methodsFor: 'accessing'!
printDate
	^(date dayOfMonth asString), ' ', (date monthName), ' ', (date year asString)! !

!NuSwikiPage methodsFor: 'accessing'!
printTime
	| stream |
	stream _ ReadWriteStream on: String new.
	time printOn: stream.
	^stream contents! !

!NuSwikiPage methodsFor: 'accessing'!
readDateFrom: aString
	date _ Date fromString: aString! !

!NuSwikiPage methodsFor: 'accessing'!
readTimeFrom: aString
	time _ Time readFrom: (ReadStream on: aString)! !

!NuSwikiPage methodsFor: 'accessing'!
reference: address given: request
	^book reference: (id asString) address: address given: request! !

!NuSwikiPage methodsFor: 'accessing'!
settings
	^settings! !

!NuSwikiPage methodsFor: 'accessing'!
settings: aDictionary
	settings _ aDictionary! !

!NuSwikiPage methodsFor: 'accessing'!
text
	"Expected to be overwritten by subclass"
	^text! !

!NuSwikiPage methodsFor: 'accessing'!
text: anObject
	text _ anObject! !

!NuSwikiPage methodsFor: 'accessing'!
time
	^time! !

!NuSwikiPage methodsFor: 'accessing'!
time: aTime
	time _ aTime! !

!NuSwikiPage methodsFor: 'accessing'!
user
	^(user isKindOf: String)
		ifTrue: [user]
		ifFalse: ['unknown']! !

!NuSwikiPage methodsFor: 'accessing'!
user: aString
	user _ aString! !

!NuSwikiPage methodsFor: 'accessing'!
writeDateOn: aStream
	aStream nextPutAll: (date dayOfMonth asString, '/', date monthIndex asString, '/', date year asString)! !

!NuSwikiPage methodsFor: 'accessing'!
writeTimeOn: aStream
	time printOn: aStream! !

!NuSwikiPage methodsFor: 'file i/o'!
backup
	"Expected to be overwritten by subclasses"
	^nil! !

!NuSwikiPage methodsFor: 'file i/o'!
fromPath: pathName
	self path: pathName.
	^self load! !

!NuSwikiPage methodsFor: 'file i/o'!
load
	"Expected to be overwritten by subclasses"
	^nil! !

!NuSwikiPage methodsFor: 'file i/o'!
versions
	"Expected to be overwritten by subclasses"
	^nil! !

!NuSwikiPage methodsFor: 'file i/o'!
write
	"Expected to be overwritten by subclasses"
	^nil! !

!NuSwikiPage methodsFor: 'processing'!
editFormatFor: request
	| formatter |

	formatter _ settings at: 'editFormatter' ifAbsent: [book settings at: 'editFormatter' ifAbsent: [^self text]].
	^(formatter format: (self text) request: request page: self) contents! !

!NuSwikiPage methodsFor: 'processing'!
flipLock: request
	[beingWritten ifNil: [false] ifNotNil: [beingWritten]] whileTrue: [Delay forSeconds: 1].
	beingWritten _ true.
	user _ request user.
	(settings includesKey: 'lock')
		ifTrue: [settings at: 'lock' put: (settings at: 'lock') not]
		ifFalse: [settings at: 'lock' put: true].
	[self getIpUser;
		text: (self text);
		backup;
		write.
	beingWritten _ false] fork.! !

!NuSwikiPage methodsFor: 'processing'!
forkWrite
	[self getIpUser;
		write;
		beingWritten: false] fork! !

!NuSwikiPage methodsFor: 'processing'!
getIpUser
	"Get the name from the IP address currently at user."
	| addr |

	addr _ NetNameResolver stringFromAddress: user.
	user _ NetNameResolver nameForAddress: user timeout: 15.
	user
		ifNil: [user _ addr]! !

!NuSwikiPage methodsFor: 'processing'!
nameFormatFor: request
	| formatter |

	formatter _ settings at: 'nameFormatter' ifAbsent: [book settings at: 'nameFormatter' ifAbsent: [^self name]].
	^(formatter format: (self name) request: request page: self) contents! !

!NuSwikiPage methodsFor: 'processing'!
reverseVersionsUsing: block
	| versions return size |

	versions _ self versions.
	return _ ''.
	size _ versions size.
	1 to: size do: [:i | return _ return, (block value: (versions at: (size + 1 - i)))].
	^return! !

!NuSwikiPage methodsFor: 'processing'!
saveFormat: newText for: request
	| formatter |

	formatter _ settings at: 'saveFormatter' ifAbsent: [book settings at: 'saveFormatter' ifAbsent: [^nil]].
	^self text: (formatter format: newText request: request page: self) contents! !

!NuSwikiPage methodsFor: 'processing'!
showFormatFor: request
	| formatter |

	formatter _ settings at: 'showFormatter' ifAbsent: [book settings at: 'showFormatter' ifAbsent: [^self text]].
	^(formatter format: (self text) request: request page: self) contents! !

!NuSwikiPage methodsFor: 'processing'!
updateTextFor: request
	| formatter |

	formatter _ settings at: 'updateFormatter' ifAbsent: [book settings at: 'updateFormatter' ifAbsent: [^nil]].
	self text: (formatter format: (self text) request: request page: self) contents.
	[self beingWritten: true.
	FileDirectory deleteFilePath: self path.
	self write.
	self beingWritten: false] fork.
! !


!NuSwikiPage class methodsFor: 'testing'!
isTextANumber: text
	"This tests if text is a positive integer."
	(text = '') ifTrue: [^false].
	text do: [:letter | letter isDigit ifFalse: [^false]].
	^true! !


!SwikiBook commentStamp: '<historical>' prior: 0!
SwikiBook

This is how a swiki is accessed. Everything goes through the book. 'process: request' returns either the text or a SwikiError.

path = Directory name of where the swiki is located
pages = The SwikiPages of this book
pageAddresses = The ways a page can be addressed (dictionary of strings to blocks)
bookAddresses = The ways the book can be addressed (dictionary of strings to blocks)
pageActions = The actions that can be used for a page (dictionary of strings to blocks)
bookActions = The actions that can be used for the book (dictionary of strings to blocks)
pageTemplates = The templates that are specific to the page; they can call either page or book actions (dictionary of strings to strings)
bookTemplates = The templates that are specific to the book; they can call book actions (dictionary of strings to strings)
settings = a place to keep the settings for the book; this is currently loaded from 'settings.xml'; It is never written
temp = a place to keep settings for the book that don't have to be saved (for instance, caches).
formatter = this is the TemplateFormatter used to format the templates!

!SwikiBook methodsFor: 'accessing'!
bookActions
	^bookActions! !

!SwikiBook methodsFor: 'accessing'!
bookActions: actions
	bookActions _ actions! !

!SwikiBook methodsFor: 'accessing'!
bookTemplates
	^bookTemplates! !

!SwikiBook methodsFor: 'accessing'!
bookTemplates: templates
	bookTemplates _ templates! !

!SwikiBook methodsFor: 'accessing'!
formatter
	^formatter! !

!SwikiBook methodsFor: 'accessing'!
formatter: aSwikiFormatter
	formatter _ aSwikiFormatter! !

!SwikiBook methodsFor: 'accessing'!
pageActions
	^pageActions! !

!SwikiBook methodsFor: 'accessing'!
pageActions: actions
	pageActions _ actions! !

!SwikiBook methodsFor: 'accessing'!
pageNamed: aString
	pages do: [:page | (page name = aString) ifTrue: [^page]].
	^nil! !

!SwikiBook methodsFor: 'accessing'!
pageTemplates
	^pageTemplates! !

!SwikiBook methodsFor: 'accessing'!
pageTemplates: templates
	pageTemplates _ templates! !

!SwikiBook methodsFor: 'accessing'!
pages
	^pages! !

!SwikiBook methodsFor: 'accessing'!
path
	^path! !

!SwikiBook methodsFor: 'accessing'!
path: aDirectoryPath
	path _ aDirectoryPath! !

!SwikiBook methodsFor: 'accessing'!
settings
	^settings! !

!SwikiBook methodsFor: 'initializing'!
actionsFromPath: pathName
	| dir f action |
	
	pageActions _ Dictionary new.
	bookActions _ Dictionary new.
	dir _ FileDirectory on: pathName.
	dir fileNames do: [:fName |
			(fName asLowercase endsWith: '.page') ifTrue: ["pageAction"
				f _ FileStream oldFileNamed: (pathName, fName).
				action _ Compiler evaluate: ('[:request :page |', f contentsOfEntireFile, ']').
				pageActions at: (fName copyFrom: 1 to: (fName size - 5)) put: action].
			(fName asLowercase endsWith: '.book') ifTrue: ["bookAction"
				f _ FileStream oldFileNamed: (pathName, fName).
				action _ Compiler evaluate: ('[:request :book |', f contentsOfEntireFile, ']').
				bookActions at: (fName copyFrom: 1 to: (fName size - 5)) put: action]].
	^self! !

!SwikiBook methodsFor: 'initializing'!
addressesFromPath: pathName
	| dir f action |
	
	pageAddresses _ Dictionary new.
	bookAddresses _ Dictionary new.
	dir _ FileDirectory on: pathName.
	dir fileNames do: [:fName |
			(fName asLowercase endsWith: '.page') ifTrue: ["pageAddress"
				f _ FileStream oldFileNamed: (pathName, fName).
				action _ Compiler evaluate: ('[:request :book |', f contentsOfEntireFile, ']').
				pageAddresses at: (fName copyFrom: 1 to: (fName size - 5)) put: action].
			(fName asLowercase endsWith: '.book') ifTrue: ["bookAddress"
				f _ FileStream oldFileNamed: (pathName, fName).
				action _ Compiler evaluate: ('[:request :book |', f contentsOfEntireFile, ']').
				bookAddresses at: (fName copyFrom: 1 to: (fName size - 5)) put: action]].
	^self! !

!SwikiBook methodsFor: 'initializing'!
fromPath: pathName
	| delim |

	delim _ String with: FileDirectory pathNameDelimiter.
	self path: pathName.
	self settingsFromPath: (pathName, 'settings.xml').
	self pagesFromPath: (pathName, 'pages', delim).
	self addressesFromPath: (pathName, 'addresses', delim).
	self actionsFromPath: (pathName, 'actions', delim).
	self templatesFromPath: (pathName, 'templates', delim).
	self formatter: (TemplateFormatter fromBook: self).
	^self! !

!SwikiBook methodsFor: 'initializing'!
pagesFromPath: pathName
	| dir number page |
	
	pages _ Dictionary new.
	dir _ FileDirectory on: pathName.
	dir fileNames do: [:fName |
		(fName asLowercase endsWith: '.xml') ifTrue: ["XmlSwikiPage"
			number _ (fName copyFrom: 1 to: (fName size - 4)) asNumber.
			page _ XmlSwikiPage new.
			page id: number.
			page book: self.
			page fromPath: (pathName, fName).
			pages at: number put: page]].
	^self! !

!SwikiBook methodsFor: 'initializing'!
settingsFromPath: pathName
	| file pos1 pos2 |

	file _ (FileStream oldFileNamed: pathName) contentsOfEntireFile.
	pos1 _ file findString: '<settings>' startingAt: 1.
	pos2 _ file findString: '</settings>' startingAt: pos1.
	^settings _ XmlSwikiPage settingsDictionaryFrom: (file copyFrom: pos1 to: pos2 + 10).
! !

!SwikiBook methodsFor: 'initializing'!
templatesFromPath: pathName
	| dir f |
	
	pageTemplates _ Dictionary new.
	bookTemplates _ Dictionary new.
	dir _ FileDirectory on: pathName.
	dir fileNames do: [:fName |
			(fName asLowercase endsWith: '.page') ifTrue: ["pageTemplate"
				f _ FileStream oldFileNamed: (pathName, fName).
				pageTemplates at: (fName copyFrom: 1 to: (fName size - 5)) put: f contentsOfEntireFile].
			(fName asLowercase endsWith: '.book') ifTrue: ["bookTemplate"
				f _ FileStream oldFileNamed: (pathName, fName).
				bookTemplates at: (fName copyFrom: 1 to: (fName size - 5)) put: f contentsOfEntireFile]].
	^self! !

!SwikiBook methodsFor: 'processing'!
addNewPage
	| test page file tokens id |

	test _ pages at: 1.
	page _ test class new.
	file _ test path.
	"Find id"
	id _ 1.
	[pages includesKey: id] whileTrue: [id _ id + 1].
	"Find pathName"
	tokens _ file findTokens: (FileDirectory pathNameDelimiter) asString.
	file _ file copyFrom: 1 to: ((file size) - (tokens last) size).
	file _ file, id asString.
	tokens _ (tokens last) findTokens: '.'.
	(tokens size > 1) ifTrue: [file _ file, '.', (tokens last)].
	"Fill in values"
	page 
		id: id;
		path: file;
		book: self;
		settings: (Dictionary new).
	"Add page to self"
	pages at: id put: page.
	^page
	! !

!SwikiBook methodsFor: 'processing'!
attachments: elementBlock ifAbsent: missingBlock
	| files return |

	files _ (FileDirectory on: (path, (self settings at: 'uploadPath' ifAbsent: [^SwikiError at: #attachmentsDirectoryMissing]), FileDirectory pathNameDelimiter asString)) fileNames.
	(files size = 0) ifTrue: [^missingBlock value].
	return _ ''.
	files do: [:fname | return _ return, (elementBlock value: fname)].
	^return
! !

!SwikiBook methodsFor: 'processing'!
pageAlmostNamed: addr ifThere: thereBlock ifNot: notBlock
	| dividers tokens isValid |

	dividers _ OrderedCollection new.
	dividers add: 1.
	(addr size > 1) ifTrue: [
		2 to: (addr size) do: [:i | (addr at: i) isUppercase ifTrue: [dividers add: i]]].
	tokens _ OrderedCollection new.
	(dividers size > 1) ifTrue: [
		1 to: (dividers size - 1) do: [:i | tokens add: (addr copyFrom: (dividers at: i) to: ((dividers at: i + 1) - 1)) asLowercase]].
	tokens add: (addr copyFrom: (dividers at: dividers size) to: addr size) asLowercase.
	pages do: [:page | isValid _ true.
		tokens do: [:token | (((page name asLowercase) findString: token) = 0) ifTrue: [isValid _ false]].
		isValid ifTrue: [^thereBlock value: page]].
	^notBlock value
! !

!SwikiBook methodsFor: 'processing'!
process: request
	"Process the swiki request to return the stream of the text."
	| address |

	(request page)
		ifNil: ["Book Request"
			address _ bookAddresses at: (request address) ifAbsent: ["It may actually be a page"
				address _ pageAddresses at: ('default')]]
		ifNotNil: ["Page Request"
			address _ pageAddresses at: (request address) ifAbsent: [bookAddresses at: (request address) ifAbsent: [^SwikiError at: #addressNotFound]]].
	^address value: request value: self.
! !

!SwikiBook methodsFor: 'processing'!
recentchanges: beforeBlock during: duringBlock after: afterBlock
	| return sortedPages page date |

	sortedPages _ SortedCollection new: (self pages size).
	sortedPages sortBlock: [:x :y | (x date = y date) ifTrue: [x time > y time] ifFalse: [x date > y date]].
	self pages do: [:element | sortedPages add: element].
	page _ sortedPages at: 1.
	date _ page date.
	"First page"
	return _ (beforeBlock value: page), (duringBlock value: page).
	"Other pages"
	(sortedPages size = 1) ifFalse: [
		2 to: (sortedPages size) do: [:i | page _ sortedPages at: i.
			(page date = date) ifFalse: ["New Date"
				date _ page date.
				return _ return, (afterBlock value), (beforeBlock value: page)].
			return _ return, (duringBlock value: page)]].
	^return, (afterBlock value).

! !

!SwikiBook methodsFor: 'processing'!
reference: page address: address given: request
	^request reference: page address: address! !

!SwikiBook methodsFor: 'processing'!
references: page before: beforeBlock during: duringBlock after: afterBlock ifAbsent: absentBlock
	| results return |

	results _ OrderedCollection new.
	pages do: [:element |
		(((element text findString: ('*', page id asString, '*')) = 0) and: [(element text findString: ('*', page name, '*')) = 0]) ifFalse: [results add: element]].
	(results size > 0) ifTrue: [
		return _ beforeBlock value: results.
		results do: [:element | return _ return, (duringBlock value: element)].
		^return, (afterBlock value: results)].
	^absentBlock value! !

!SwikiBook methodsFor: 'processing'!
searchresult: text before: beforeBlock during: duringBlock after: afterBlock ifAbsent: absentBlock
	| tokens results isMatch return |

	tokens _ text findTokens: ' '.
	(tokens size = 0) ifFalse: [
		results _ OrderedCollection new.
		pages do: [:page | "Test Pages in an and search manner"
			isMatch _ true.
			tokens do: [:token |
				((((page text) findString: token) = 0) and: [((page name) findString: token) = 0])
					ifTrue: [isMatch _ false]].
			isMatch ifTrue: [results add: page]].
		(results size > 0) ifTrue: ["Add Pages"
			return _ beforeBlock value: results.
			results do: [:page | return _ return, (duringBlock value: page)].
			^return, (afterBlock value: results)]].
	^absentBlock value! !

!SwikiBook methodsFor: 'testing'!
hasPageNamed: aString
	pages do: [:page | (page name = aString) ifTrue: [^true]].
	^false! !


!SwikiBook class methodsFor: 'instance creation'!
fromPath: pathName
	| delim |

	delim _ String with: FileDirectory pathNameDelimiter.
	^self new fromPath: ((pathName endsWith: delim) ifTrue: [pathName] ifFalse: [pathName, delim]).! !


!SwikiError commentStamp: '<historical>' prior: 0!
SwikiError

This is a type of error that is return by a SwikiBook when things didn't go according to plan.

Instance Variables:
httpMessage = the message the error should send out for a http reply
httpStatusCode = the status code the error should send out for a http reply

Class Variable:
Common = a dictionary of common errors
!

!SwikiError methodsFor: 'accessing'!
httpMessage
	^httpMessage! !

!SwikiError methodsFor: 'accessing'!
httpMessage: aString
	httpMessage _ aString! !

!SwikiError methodsFor: 'accessing'!
httpStatusCode
	^httpStatusCode! !

!SwikiError methodsFor: 'accessing'!
httpStatusCode: aString
	httpStatusCode _ aString! !


!SwikiError class methodsFor: 'accessing'!
at: key
	^Common at: key ifAbsent: [nil]! !

!SwikiError class methodsFor: 'initialize-release'!
initialize
	Common _ Dictionary new.
	Common
		at: #pageDoesNotExist put: (self new httpStatusCode: '404 Not Found'; httpMessage: ('<html>', String cr, '<head><title>404 Not Found</title></head>', String cr, '<body>', String cr, '<h1>Not Found</h1>', String cr, '<p>That page does not exist on this Swiki</p>', String cr, '</body>', String cr, '</html>'));
		at: #textFormatterMissing put: ('Error: Text Formatter is Missing');
		at: #bookNameMissing put: ('Error: Book Name is Missing');
		at: #addressNotFound put: (self new httpStatusCode: '404 Not Found'; httpMessage: ('<html>', String cr, '<head><title>404 Not Found</title></head>', String cr, '<body>', String cr, '<h1>Not Found</h1>', String cr, '<p>That addressing is not valid for this Swiki</p>', String cr, '</body>', String cr, '</html>'));
		at: #attachmentsDirectoryMissing put: ('Error: Attachments Directory Missing').! !


!SwikiModule commentStamp: '<historical>' prior: 0!
SwikiModule

This class gets Comanche to talk to swiki.!

!SwikiModule methodsFor: 'accessing'!
book
	^book! !

!SwikiModule methodsFor: 'accessing'!
book: aSwikiBook
	book _ aSwikiBook! !

!SwikiModule methodsFor: 'processing'!
filter: rawRequest
	^SwikiRequest for: self fromRequest: rawRequest! !

!SwikiModule methodsFor: 'processing'!
processAfterModules: request
	| return |
	(request isKindOf: SwikiRequest) ifTrue: [
		return _ book process: request.
		(return isKindOf: SwikiError)
			ifTrue: [request serveError: return]
			ifFalse: [return _ ReadStream on: return contents.
				request serveHtml: return]].
	^request! !


!SwikiRequest commentStamp: '<historical>' prior: 0!
SwikiRequest

This class is used by Comanche for requests that can be sent to the SwikiBook.
"aSwikiBook process: aSwikiRequest" will return either text of a SwikiError.!

!SwikiRequest methodsFor: 'accessing'!
address
	(urlTokens size < 2) ifTrue: [^'default'].
	(urlTokens last) do: [:char | (char isDigit) ifFalse: [^urlTokens last]].
	^'default'! !

!SwikiRequest methodsFor: 'accessing'!
appendID
	^1! !

!SwikiRequest methodsFor: 'accessing'!
appendText
	^''! !

!SwikiRequest methodsFor: 'accessing'!
lockPassword
	^self postFields at: 'password' ifAbsent: ['']! !

!SwikiRequest methodsFor: 'accessing'!
name
	^self postFields at: 'name' ifAbsent: ['Bad'].! !

!SwikiRequest methodsFor: 'accessing'!
page
	(urlTokens size < 2) ifTrue: [^1].
	(NuSwikiPage isTextANumber: (urlTokens at: 2))
		ifTrue: [^(urlTokens at: 2) asNumber]
		ifFalse: [(urlTokens size < 3)
			ifTrue: [^nil]
			ifFalse: [^(PageFormatter fromSafeUrl format: (urlTokens at: 2)) contents]].! !

!SwikiRequest methodsFor: 'accessing'!
reference: page address: address
	(page = '')
		ifTrue: [^urlPrefix, address]
		ifFalse: [(address = '')
			ifTrue: [^urlPrefix, page]
			ifFalse: [^urlPrefix, page, '.', address]].
! !

!SwikiRequest methodsFor: 'accessing'!
referringPage
	| tokens |

	tokens _ (header at: 'referer' ifAbsent: [^nil]) findTokens: './'.
	(tokens size = 0) ifTrue: [^nil].
	(NuSwikiPage isTextANumber: tokens last)
		ifTrue: [^tokens last asNumber]
		ifFalse: [^nil]! !

!SwikiRequest methodsFor: 'accessing'!
search
	^self postFields at: 'search' ifAbsent: ['']! !

!SwikiRequest methodsFor: 'accessing'!
text
	^self postFields at: 'text' ifAbsent: ['']! !

!SwikiRequest methodsFor: 'accessing'!
urlPrefix: aString
	urlPrefix _ aString! !

!SwikiRequest methodsFor: 'accessing'!
urlTokens: tokens
	urlTokens _ tokens! !

!SwikiRequest methodsFor: 'accessing'!
user
	"Give IP address since this is the closest that an HttpRequest without login, password."
	^self remoteAddress! !

!SwikiRequest methodsFor: 'serving'!
serveError: error
	| message chunk chunkSize |

	message _ ReadStream on: error httpMessage.
	"Header"
	stream nextPutAll: protocol, ' ', error httpStatusCode, String crlf;
		nextPutAll: 'Content-type: ', MIMEDocument contentTypeHtml, String crlf;
		nextPutAll: 'Content-length: ', (message size asString), String crlf;
		nextPutAll: String crlf.
	"Body"
	chunkSize _ 4096.
	[message atEnd]
		whileFalse:
			[chunk _ message next: chunkSize.
			stream nextPutAll: chunk.
			Delay forMilliseconds: 50].! !

!SwikiRequest methodsFor: 'serving'!
serveHtml: htmlStream
	| chunk chunkSize |

	"Header"
	stream nextPutAll: protocol, ' 200 OK', String crlf;
		nextPutAll: 'Content-type: ', MIMEDocument contentTypeHtml, String crlf;
		nextPutAll: 'Content-length: ', (htmlStream size asString), String crlf;
		nextPutAll: String crlf.
	"Body"
	chunkSize _ 4096.
	[htmlStream atEnd]
		whileFalse:
			[chunk _ htmlStream next: chunkSize.
			stream nextPutAll: chunk.
			Delay forMilliseconds: 50].! !

!SwikiRequest methodsFor: 'testing'!
isAppend
	^false! !

!SwikiRequest methodsFor: 'testing'!
isEdit
	(postFields isKindOf: Dictionary) ifTrue: [^postFields includesKey: 'text'].
	^false! !

!SwikiRequest methodsFor: 'testing'!
isFramesCapable
	^((self header at: 'user-agent' ifAbsent: [^false]) asLowercase beginsWith: 'lynx') not! !

!SwikiRequest methodsFor: 'testing'!
isLockChange
	(postFields isKindOf: Dictionary) ifTrue: [^postFields includesKey: 'password'].
	^false! !

!SwikiRequest methodsFor: 'testing'!
isSearch
	(postFields isKindOf: Dictionary) ifTrue: [^postFields includesKey: 'search'].
	^false! !


!SwikiRequest class methodsFor: 'instance creation'!
for: module fromRequest: rawRequest
	| tokens request |

	tokens _ rawRequest url findTokens: '/.'.
	(tokens isEmpty or: [(tokens at: 1) = module name])
		ifFalse: ["Not for this module" ^nil].
	request _ self fromRequest: rawRequest.
	request urlTokens: tokens.
	request urlPrefix: ('/', module name, '/').
	^request
	! !


!TextFormatter commentStamp: '<historical>' prior: 0!
TextFormatter

This is a general text formatter. You create an instance which is a text formatter. Then, using 'format:' you format a text to get a formatted stream back.

There are two type of formatting that can be added: mapping and action. A mapping is when an original in the text gets replaced with the replacement in the formatted stream. An action is when the text between the two elements is send into the code block and the result is sent to the formatted stream. In case of conflict, the longer match wins; for instance, in a SwikiFormatter, '----' might match to '<HR>', while '-' might match to '<LI>'.!

!TextFormatter methodsFor: 'accessing'!
addAction: block from: beginning to: end
	"When the Action is performed, the text is scanned for things that start with beginning
	and stop with end. Whatever is between these two is then put into the block and what
	gets returned is fed to the formatted document."
	"The format for an Action is a 3 element array of (beginning end block)."
	| starts formatter |

	starts _ beginning at: 1.
	match add: starts.
	formatter _ Array new: 3.
	beginning size = 1
		ifTrue: [formatter at: 1 put: '']
		ifFalse: [formatter at: 1 put: (beginning copyFrom: 2 to: beginning size)].
	formatter at: 2 put: end.
	formatter at: 3 put: block.
	self addFormatter: formatter at: (starts asInteger).! !

!TextFormatter methodsFor: 'accessing'!
addMappingFrom: original to: replacement
	"A Mapping is when the text is scanned and all instances of original are mapped to
	their replacements."
	"The format for a Mapping is an 3 element array of (original nil replacement)."
	| starts formatter |

	starts _ original at: 1.
	match add: starts.
	formatter _ Array new: 3.
	original size = 1
		ifTrue: [formatter at: 1 put: '']
		ifFalse: [formatter at: 1 put: (original copyFrom: 2 to: original size)].
	formatter at: 3 put: replacement.
	self addFormatter: formatter at: (starts asInteger).! !

!TextFormatter methodsFor: 'accessing'!
remove: key
	"Removes a formatter (action, mapping) from the TextFormatter."
	"It remove it if it matches the orginal for a mapping or the beginning for an action."
	| starts formatters ends |

	starts _ key at: 1. "First character in the key."
	formatters _ formattingArray at: (starts asInteger).
	formatters ifNil: ["There is no matching formatter, so stop" ^nil]
		ifNotNil: [((key size) = 1) ifTrue: [ends _ ''] ifFalse: [ends _ key copyFrom: 2 to: (key size)].
			formatters do: [:element | ((element at: 1) = ends) ifTrue: [formatters remove: element]].
			((formatters size) = 0) ifTrue: [
				formattingArray at: (starts asInteger) put: nil. "Removes formatter"
				match remove: starts. "Removes from match"
			]
		].
	^nil! !

!TextFormatter methodsFor: 'initializing'!
initialize
	match _ CharacterSet new.
	formattingArray _ Array new: 255.! !

!TextFormatter methodsFor: 'private'!
action: action value: value text: text
	^action value: text! !

!TextFormatter methodsFor: 'private'!
addFormatter: formatter at: position
	"Adds a formatter to the position in the formattingArray."
	| formatters |

	formatters _ formattingArray at: position.
	formatters isNil
		ifTrue: [formatters _ SortedCollection new sortBlock: [:x :y | (x at: 1) size >= (y at: 1) size].
			formattingArray at: position put: formatters].
	formatters add: formatter.
! !

!TextFormatter methodsFor: 'private'!
format: text actionValue: value onTo: stream
	"Apply all the formatting on text and put it onto stream."
	| pos i maxSize formatters index formatter |

	"i is the position of a match"
	pos _ 1. "Position in text, marking the seperation of processed and yet to be processed"
	[(i _ text indexOfAnyOf: match startingAt: pos) > 0]
		whileTrue: [stream nextPutAll: (text copyFrom: pos to: i-1). "No formatting in this space"
			maxSize _ text size - i.
			formatters _ formattingArray at: (text at: i) asInteger.
			index _ 1.
			[formatters size >= index] "Index of Formatters"
				whileTrue: [ "see if formatters match"
					formatter _ formatters at: index.
					"Check that size of formatter is allowed."
					(maxSize >= (formatter at: 1) size) ifTrue: [
						"Check if the formatter matches"
						((text copyFrom: (i + 1) to: (i + (formatter at: 1) size)) = (formatter at: 1))
							ifTrue: [ index _ formatters size + 1. "Match => exit loop"
								"Set i to beyond beginning marker"
								pos _ i + 1 + (formatter at: 1) size.
								(formatter at: 2)
									ifNil: [ "Mapping"
											stream nextPutAll: (formatter at: 3)
										]
									ifNotNil: [ "Action"
											"This does not allow nesting, but that's probably good."
											i _ text findString: (formatter at: 2) startingAt: pos.
											"Check for no closing"
											i > 0 ifTrue: [stream nextPutAll: (self action: (formatter at: 3) value: value text: (text copyFrom: pos to: i-1)).
													pos _ i + (formatter at: 2) size
												]
										]
								]
						].
					index _ index + 1.
				].
				"Check for no formatter matched"
				((formatters size) = (index - 1)) ifTrue: [stream nextPut: (text at: i). pos _ i + 1]
		].
		"Add last section if there is one."
		(pos <= text size) ifTrue: [stream nextPutAll: (text copyFrom: pos to: (text size))].
	 ^stream! !

!TextFormatter methodsFor: 'processing'!
format: text
	"Apply all the formatting to the text and return it as a stream"
	| return |

	"Create a new stream to write it on."
	return _ WriteStream on: (String new: text size).
	self format: text onTo: return.
	^return
! !

!TextFormatter methodsFor: 'processing'!
format: text onTo: stream
	^self format: text actionValue: nil onTo: stream! !


!PageFormatter commentStamp: '<historical>' prior: 0!
PageFormatter

This formatter is used to format the page text at various points in the swiki architecture.

Specific Instances:
editFormatter: used to convert the raw page text to the edit text
saveFormatter: used to convert the edit text from the user to the raw text for the file
showFormatter: used to convert the raw text to the HTML seen by the user normally

Class Variables:
ToSafeUrl: converts normal text into something that can be put into a url without messing up the url
FromSafeUrl: does the opposite of ToSageUrl
Remove CrLf: removes all instances of Cr Lf or CrLf!

!PageFormatter methodsFor: 'accessing'!
storeID
	^storeID! !

!PageFormatter methodsFor: 'accessing'!
storeID: id
	storeID _ id! !

!PageFormatter methodsFor: 'functionality'!
addBreaks
	self addMappingFrom: String cr, String cr to: '<p>'.
	self addMappingFrom: String cr to: '<br>'.! !

!PageFormatter methodsFor: 'functionality'!
addChangeLinks
	self addAction: [:request :page :text | (NuSwikiPage isTextANumber: text)
		ifTrue: [(page book pages includesKey: text asNumber)
			ifTrue: ['*', (page book pages at: text asNumber) name, '*']
			ifFalse: ['Error: missing page']]
		ifFalse: ['*', text, '*']] from: '*' to: '*'.! !

!PageFormatter methodsFor: 'functionality'!
addCrlfToCr
	self addMappingFrom: String crlf to: String cr.
	self addMappingFrom: (Character lf asString) to: String cr.! !

!PageFormatter methodsFor: 'functionality'!
addEditSpecialCharacters
	self addMappingFrom: '&amp;' to: '&amp;&amp;'.
	self addMappingFrom: '&lt;' to: '&amp;&lt;'.
	self addMappingFrom: '&gt;' to: '&amp;&gt;'.
	self addMappingFrom: '&*' to: '&amp;*'.
	self addMappingFrom: '&' to: '&amp;'.
	self addMappingFrom: '<' to: '&lt;'.
	self addMappingFrom: '>' to: '&gt;'! !

!PageFormatter methodsFor: 'functionality'!
addHeaders
	| value |

	self addAction: [:request :page :text | value _ 1.
		[(text at: value) = $=] whileTrue: [value _ value + 1].
		String cr, '<h', value asString, '>', (self format: (text copyFrom: value to: (text size)) request: request page: page) contents, '</h', value asString, '>', String cr] from: String cr, '=' to: String cr
! !

!PageFormatter methodsFor: 'functionality'!
addInternalLinks
	| temp |

	self addAction: [:request :page :text | (NuSwikiPage isTextANumber: text)
		ifTrue: [(page book pages includesKey: text asNumber)
			ifTrue: [temp _ page book pages at: text asNumber.
				'<a href="', (temp reference: '' given: request), '">', temp name, '</a>']
			ifFalse: ['Error: this should not happen']]
		ifFalse: [(page book hasPageNamed: text)
			ifTrue: [temp _ page book pageNamed: text.
				'<a href="', (temp reference: '' given: request), '">', temp name, '</a>']
			ifFalse: [(text beginsWith: 'http')
				ifTrue: [(((text endsWith: 'gif') or: [text endsWith: 'jpg']) or: [text endsWith: 'jpeg'])
					ifTrue: ['<img src="', text, '">']
					ifFalse: ['<a href="', text, '">', text, '</a>']]
				ifFalse: ["New Page"
					'[', text, ': <a href="', (page book reference: (PageFormatter toSafeUrl format: text) contents address: 'edit' given: request), '">create</a>]']]]] from: '*' to: '*'.
	self addMappingFrom: '&*' to: '*'! !

!PageFormatter methodsFor: 'functionality'!
addLinesToHR
	self addMappingFrom: String cr, '----', String cr to: '<br>', String cr, '<hr>', String cr! !

!PageFormatter methodsFor: 'functionality'!
addList
	self addMappingFrom: String cr, '-' to: String cr, '<li>'.
	self addAction: [:request :page :text | String cr, '<ul>', String cr, '<li>', (self format: text request: request page: page) contents, String cr, '</ul>', String cr] from: String cr, String cr, '-' to: String cr, String cr

! !

!PageFormatter methodsFor: 'functionality'!
addNameCharacters
	self addMappingFrom: '"' to: '&quot;'.
	self addMappingFrom: '<' to: '&lt;'.
	self addMappingFrom: '>' to: '&gt;'.
	self addMappingFrom: '&' to: '&amp;'.! !

!PageFormatter methodsFor: 'functionality'!
addReverseLinks
	self addAction: [:request :page :text | (page book hasPageNamed: text)
		ifTrue: ['*', (page book pageNamed: text) id asString, '*']
		ifFalse: ['*', (PageFormatter removeCrLf format: text) contents, '*']] from: '*' to: '*'.
	self addMappingFrom: '&*' to: '&*'! !

!PageFormatter methodsFor: 'functionality'!
addSaveSpecialCharacters
	self addMappingFrom: '&&' to: '&amp;'.
	self addMappingFrom: '&<' to: '&lt;'.
	self addMappingFrom: '&>' to: '&gt;'! !

!PageFormatter methodsFor: 'functionality'!
addTagIntegrity
	self addAction: [:request :page :text | '<', text, '>' ] from: '<' to: '>'
! !

!PageFormatter methodsFor: 'functionality'!
addUpdateLinks
	self addAction: [:request :page :text | (NuSwikiPage isTextANumber: text)
		ifTrue: ['*', text, '*']
		ifFalse: [(page book hasPageNamed: text)
			ifTrue: ['*', ((page book pageNamed: text) id asString), '*']
			ifFalse: ['*', text, '*']]] from: '*' to: '*'.
	self addMappingFrom: '&*' to: '&*'.! !

!PageFormatter methodsFor: 'functionality'!
addUploadLinks
	self addAction: [:request :page :text |
		(((text endsWith: 'gif') or: [text endsWith: 'jpg']) or: [text endsWith: 'jpeg'])
			ifTrue: ['<img src="', text, '">']
					ifFalse: ['<a href="', (page book reference: '' address: ('uploads/', text) given: request), '">', text, '</a>']] from: '*+' to: '+*'! !

!PageFormatter methodsFor: 'private'!
action: action value: value text: text
	^action value: (value at: 1) value: (value at: 2) value: text.! !

!PageFormatter methodsFor: 'private'!
storeString
	"Overwrite of Object method to save space for storing"
	(storeID) ifNotNil: ["Check to make sure this storeID is valid"
		(self class respondsTo: storeID)
			ifTrue: [^'(', self class asString, ' ', storeID asString, ')']].
	^super storeString! !

!PageFormatter methodsFor: 'processing'!
format: text request: request page: page
	|value stream|

	stream _ WriteStream on: (String new: text size).
	value _ Array new: 2.
	value at: 1 put: request.
	value at: 2 put: page.
	self format: text actionValue: value onTo: stream.
	^stream! !


!TemplateFormatter commentStamp: '<historical>' prior: 0!
TemplateFormatter

This specialty TextFormatter is created for a SwikiBook to use in processing templates. It takes elements between '<?' and '?>' and executes the actions associated with the text inbetween.!

!TemplateFormatter methodsFor: 'accessing'!
book
	^book! !

!TemplateFormatter methodsFor: 'accessing'!
book: aSwikiBook
	book _ aSwikiBook! !

!TemplateFormatter methodsFor: 'private'!
action: action value: value text: text
	"Overwrites parent class to add swiki action"
	| lookup |

	(action = #swikiAction) ifFalse: [^action value: text]
		ifTrue: ["Swiki Action"
			 (value at: 1) = #page
				ifTrue: ["Page Request"
					lookup _ book pageActions at: text ifAbsent: [nil].
					lookup
						ifNotNil: ["Page Action"
							^lookup value: (value at: 2) value: (value at: 3)]
						ifNil: ["Book Action"
							lookup _ book bookActions at: text ifAbsent: [^'<?', text, '?>'].
							^lookup value: (value at: 2) value: book]]
				ifFalse: ["Book Request"
					lookup _ book bookActions at: text ifAbsent: [^'<?', text, '?>'].
					^lookup value: (value at: 2) value: book]].! !

!TemplateFormatter methodsFor: 'processing'!
format: template request: request
	"Formatting used for a book request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array new: 2.
	value at: 1 put: #book.
	value at: 2 put: request.
	self format: template actionValue: value onTo: stream.
	^stream! !

!TemplateFormatter methodsFor: 'processing'!
format: template request: request page: page
	"Formatting used for a page request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array new: 3.
	value at: 1 put: #page.
	value at: 2 put: request.
	value at: 3 put: page.
	self format: template actionValue: value onTo: stream.
	^stream! !


!TextFormatter class methodsFor: 'instance creation'!
fixForIEFormatter
	"Creates an instance that fixes the mark-ups for Internet Explorer.
	These are simply the alternatives for '&', '<', and '>'."
	| fm |

	fm _ self new.
	fm initialize.
	fm addMappingFrom: '<' to: '&lt;'.
	fm addMappingFrom: '>' to: '&gt;'.
	fm addMappingFrom: '&' to: '&amp;'.
	^fm! !


!PageFormatter class methodsFor: 'accessing'!
fromSafeUrl
	^FromSafeUrl! !

!PageFormatter class methodsFor: 'accessing'!
removeCrLf
	^RemoveCrLf! !

!PageFormatter class methodsFor: 'accessing'!
toSafeUrl
	^ToSafeUrl! !

!PageFormatter class methodsFor: 'initialize-release'!
initialize
	"Add utility formatters"
	RemoveCrLf _ TextFormatter new.
	RemoveCrLf initialize;
		addMappingFrom: String cr to: '';
		addMappingFrom: (Character lf) asString to: ''.
	FromSafeUrl _ TextFormatter new.
	FromSafeUrl initialize;
		addMappingFrom: '__' to: ' ';
		addMappingFrom: '_0' to: ' ';
		addMappingFrom: '_1' to: '.';
		addMappingFrom: '_2' to: '/';
		addMappingFrom: '_3' to: ':';
		addMappingFrom: '_4' to: '%'.
	ToSafeUrl _ TextFormatter new.
	ToSafeUrl initialize;
		addMappingFrom: ' ' to: '__';
		addMappingFrom: '_' to: '_0';
		addMappingFrom: '.' to: '_1';
		addMappingFrom: '/' to: '_2';
		addMappingFrom: ':' to: '_3';
		addMappingFrom: '%' to: '_4'.! !

!PageFormatter class methodsFor: 'instance creation'!
editFormatter
	| return |
	return _ self new.
	return initialize;
		addChangeLinks;
		addEditSpecialCharacters;
		storeID: #editFormatter.
	^return! !

!PageFormatter class methodsFor: 'instance creation'!
nameFormatter
	| return |
	return _ self new.
	return initialize;
		addNameCharacters;
		storeID: #nameFormatter.
	^return! !

!PageFormatter class methodsFor: 'instance creation'!
saveFormatter
	| return |
	return _ self new.
	return
		initialize;
		addCrlfToCr;
		addReverseLinks;
		addSaveSpecialCharacters;
		storeID: #saveFormatter.
	^return! !

!PageFormatter class methodsFor: 'instance creation'!
showFormatter
	| return |
	return _ self new.
	return initialize;
		addBreaks;
		addHeaders;
		addInternalLinks;
		addLinesToHR;
		addList;
		addTagIntegrity;
		addUploadLinks;
		storeID: #showFormatter.
	^return! !

!PageFormatter class methodsFor: 'instance creation'!
updateFormatter
	| return |
	
	return _ self new.
	return initialize;
		addUpdateLinks;
		storeID: #updateFormatter.
	^return! !


!TemplateFormatter class methodsFor: 'instance creation'!
fromBook: aSwikiBook
	| fm |
	fm _ self new.
	fm initialize.
	fm book: aSwikiBook.
	fm addAction: #swikiAction from: '<?' to: '?>'.
	^fm! !


!XmlSwikiPage commentStamp: '<historical>' prior: 0!
XmlSwikiPage

This subclass of NuSwikiPage is used to interface the swiki page with an XML file containing the information. To understand the file format, look at an example file.

Class Variables:
FromXML = a TextFormatter used to convert XML text to normal text (&<>)
ToXML = a TextFormatter used to convert normal text to XML (&<>)!

!XmlSwikiPage methodsFor: 'accessing'!
text
	| file return |

	(text isKindOf: String)
		ifTrue: [^text]
		ifFalse: [file _ FileStream oldFileNamed: path.
			file position: (text at: 1).
			return _ (FromXml format: (file next: ((text at: 2) - (text at: 1)))) contents.
			file close.
			^return].! !

!XmlSwikiPage methodsFor: 'file i/o'!
backup
	"Back-up a .xml page to put it's contents into a .old page."
	| oldPath oldStream file pos |

	"Get the path for the .old file."
	oldPath _ (path copyFrom: 1 to: (path size - 4)), '.old'.
	"Get the .old stream to write on"
	(FileStream isAFileNamed: oldPath)
		ifTrue: [oldStream _ FileStream oldFileNamed: oldPath.
				oldStream setToEnd]
		ifFalse: [oldStream _ FileStream newFileNamed: oldPath].
	file _ (FileStream oldFileNamed: path) contentsOfEntireFile.
	pos _ file findString: '<page>' startingAt: 1.
	"Add current page."
	oldStream nextPutAll: (file copyFrom: pos to: file size).
	oldStream nextPutAll: String cr.
	oldStream close.
	"Delete current file."
	FileDirectory deleteFilePath: path.
	^self! !

!XmlSwikiPage methodsFor: 'file i/o'!
load
	| xml pos1 pos2 arr |

	xml _ (FileStream oldFileNamed: path) contentsOfEntireFile.
	"Version"
	pos1 _ xml findString: '<version date="' startingAt: 1.
	pos2 _ xml findString: '" time="' startingAt: pos1.
	self readDateFrom: (xml copyFrom: (pos1 + 15) to: (pos2 - 1)).
	pos1 _ xml findString: '" user="' startingAt: pos2.
	self readTimeFrom: (xml copyFrom: (pos2 + 8) to: (pos1 - 1)).
	pos2 _ xml findString: '" />' startingAt: pos1.
	user _ xml copyFrom: (pos1 + 8) to: (pos2 - 1).
	"Settings"
	pos1 _ xml findString: '<settings>' startingAt: pos2.
	pos2 _ xml findString: '</settings>' startingAt: pos1.
	settings _ self class settingsDictionaryFrom: (xml copyFrom: (pos1) to: (pos2 + 10)).
	"Name"
	pos1 _ xml findString: '<name>' startingAt: pos2.
	pos2 _ xml findString: '</name>' startingAt: pos1.
	name _ (FromXml format: (xml copyFrom: (pos1 + 6) to: (pos2 - 1))) contents.
	"Text"
	pos1 _ xml findString: '<text>' startingAt: pos2.
	pos2 _ xml findString: '</text>' startingAt: pos1.
	arr _ Array new: 2.
	arr at: 1 put: (pos1 + 5).
	arr at: 2 put: (pos2 - 1).
	self text: arr.
! !

!XmlSwikiPage methodsFor: 'file i/o'!
loadFrom: xml
	| pos1 pos2 |

	"Version"
	pos1 _ xml findString: '<version date="' startingAt: 1.
	pos2 _ xml findString: '" time="' startingAt: pos1.
	self readDateFrom: (xml copyFrom: (pos1 + 15) to: (pos2 - 1)).
	pos1 _ xml findString: '" user="' startingAt: pos2.
	self readTimeFrom: (xml copyFrom: (pos2 + 8) to: (pos1 - 1)).
	pos2 _ xml findString: '" />' startingAt: pos1.
	user _ xml copyFrom: (pos1 + 8) to: (pos2 - 1).
	"Settings"
	pos1 _ xml findString: '<settings>' startingAt: pos2.
	pos2 _ xml findString: '</settings>' startingAt: pos1.
	settings _ self class settingsDictionaryFrom: (xml copyFrom: (pos1) to: (pos2 + 10)).
	"Name"
	pos1 _ xml findString: '<name>' startingAt: pos2.
	pos2 _ xml findString: '</name>' startingAt: pos1.
	name _ (FromXml format: (xml copyFrom: (pos1 + 6) to: (pos2 - 1))) contents.
	"Text"
	pos1 _ xml findString: '<text>' startingAt: pos2.
	pos2 _ xml findString: '</text>' startingAt: pos1.
	text _ (FromXml format: (xml copyFrom: (pos1 + 6) to: (pos2 - 1))) contents.
! !

!XmlSwikiPage methodsFor: 'file i/o'!
versions
	"Returns a collection of XmlSwikiPage(s) of old and new version(s).
	You are guaranteed at least one version since the current one works."
	| oldPath oldText versions oldPage pos1 pos2 |

	versions _ OrderedCollection new.
	"Get the pages for the .old file."
	oldPath _ (path copyFrom: 1 to: (path size - 4)), '.old'.
	(FileStream isAFileNamed: oldPath)
		ifTrue: ["Add Old Versions"
			oldText _ (FileStream oldFileNamed: oldPath) contentsOfEntireFile.
			pos1 _ 1.
			pos2 _ 1.
			[(pos1 _ oldText findString: '<page>' startingAt: pos2) = 0] whileFalse: [
				pos2 _ oldText findString: '</page>' startingAt: pos1.
				oldPage _ self class new.
				oldPage
					loadFrom: (oldText copyFrom: pos1 to: (pos2 + 6));
					id: id;
					book: book.
				versions add: oldPage]].
	versions add: self.
	^versions! !

!XmlSwikiPage methodsFor: 'file i/o'!
write
	| file pos |

	file _ FileStream newFileNamed: path.
	file nextPutAll: '<?xml version="1.0"?>', String cr.
	file nextPutAll: '<page>', String cr.
	"Version"
	file nextPutAll: '<version date="'.
	self writeDateOn: file.
	file nextPutAll: '" time="'.
	self writeTimeOn: file.
	file nextPutAll: '" user="', self user, '" />', String cr.
	"Settings"
	file nextPutAll: (self class settingsStringFrom: settings).
	"Name"
	file nextPutAll: '<name>'.
	ToXml format: self name onTo: file.
	file nextPutAll: '</name>', String cr.
	"Text"
	file nextPutAll: '<text>'.
	pos _ Array new: 2.
	pos at: 1 put: file position.
	ToXml format: self text onTo: file.
	pos at: 2 put: file position.
	self text: pos.
	file nextPutAll: '</text>', String cr.
	file nextPutAll: '</page>'.
	file close.! !


!XmlSwikiPage class methodsFor: 'initialize-release'!
initialize
	ToXml _ TextFormatter new.
	ToXml initialize;
		addMappingFrom: '<' to: '&lt;';
		addMappingFrom: '>' to: '&gt;';
		addMappingFrom: '&' to: '&amp;'.
	FromXml _ TextFormatter new.
	FromXml initialize;
		addMappingFrom: '&lt;' to: '<';
		addMappingFrom: '&gt;' to: '>';
		addMappingFrom: '&amp;' to: '&'.! !

!XmlSwikiPage class methodsFor: 'accessing'!
fromXml
	FromXml ifNil: [self class initialize].
	^FromXml! !

!XmlSwikiPage class methodsFor: 'accessing'!
toXml
	ToXml ifNil: [self class initialize].
	^ToXml! !

!XmlSwikiPage class methodsFor: 'conversion'!
settingsDictionaryFrom: xml
	"Converts a xml string to a dictionary.
	xml strings are of this form:
	<settings>
	<s name=""key1"">value1</s>
	<s name=""key2"">value2</s> ...
	</settings>"
	| dict pos1 pos2 key value |

	dict _ Dictionary new.
	pos2 _ 1.
	[pos1 _ xml findString: '<s name="' startingAt: pos2. pos1 = 0] whileFalse: ["Keep adding elements"
		pos2 _ xml findString: '">' startingAt: pos1.
		key _ (FromXml format: (xml copyFrom: (pos1 + 9) to: (pos2 - 1))) contents.
		pos1 _ xml findString: '</s>' startingAt: pos2.
		value _ Compiler evaluate: (FromXml format: (xml copyFrom: (pos2 + 2) to: (pos1 - 1))) contents.
		dict at: key put: value.
		pos2 _ pos1 + 2].
	^dict
! !

!XmlSwikiPage class methodsFor: 'conversion'!
settingsStringFrom: dict
	"Converts a dictionary to a xml string."
	| xml |

	xml _ '<settings>', String cr.
	dict associationsDo: [:association | xml _ xml, '<s name="', (ToXml format: association key) contents, '">', (ToXml format: association value storeString) contents, '</s>', String cr].
	^xml, '</settings>', String cr.
! !


SwikiError initialize!
PageFormatter initialize!
XmlSwikiPage initialize!
